<p-dialog
  title="Recipe Details"
  [(visible)]="display"
  [modal]="true"
  [closable]="false"
  [style]="{ width: '50vw' }"
>
  <p-panel header="Recipe Details" styleClass="recipe-panel">
    <div class="p-fluid grid">
      <div class="full-row-recipe-field">
        <label for="recipe-name">Name</label>
        <input
          id="recipe-name"
          type="text"
          pInputText
          [(ngModel)]="recipe.name"
        />
      </div>
      <div class="col-12">
        <h3>Ingredients</h3>
        <p-table *ngIf="recipe.ingredients" [value]="recipe.ingredients">
          <ng-template pTemplate="header">
            <tr>
              <th>Name</th>
              <th>Amount</th>
              <th>Type</th>
              <th></th>
            </tr>
          </ng-template>
          <ng-template pTemplate="body" let-ingredient>
            <tr>
              <td>{{ ingredient.name }}</td>
              <td>{{ ingredient.amount }}</td>
              <td>{{ ingredient.type }}</td>
              <td>
                <button
                  pButton
                  (click)="deleteIngredient(ingredient)"
                  label="Delete"
                ></button>
              </td>
            </tr>
          </ng-template>
        </p-table>
        <div class="recipe-field">
          <button
            pButton
            (click)="showAddIngredient()"
            label="Add Ingredient"
          ></button>
        </div>
      </div>
      <div class="recipe-field">
        <label for="recipe-appliance">Appliance</label>
        <input
          id="recipe-appliance"
          type="text"
          pInputText
          [(ngModel)]="recipe.appliance"
        />
      </div>
      <div class="recipe-field">
        <label for="recipe-time-to-make">Time to Make</label>
        <input
          id="recipe-time-to-make"
          type="text"
          pInputText
          [(ngModel)]="recipe.timeToMake"
        />
      </div>
      <div class="recipe-field">
        <label for="recipe-portions">Portions</label>
        <p-inputNumber
          id="recipe-portions"
          [(ngModel)]="recipe.portions"
        ></p-inputNumber>
      </div>
      <div class="field col-12">
        <label for="recipe-instructions">Instructions</label>
        <textarea
          id="recipe-instructions"
          pInputTextarea
          [rows]="10"
          [cols]="110"
          [(ngModel)]="recipe.instructions"
        ></textarea>
      </div>
    </div>
    <div class="p-fluid grid align-items-center">
      <div class="field col-6">
        <button pButton (click)="saveRecipe()" label="Save"></button>
      </div>
      <div class="field col-6">
        <button pButton (click)="cancelSave()" label="Cancel"></button>
      </div>
    </div>

    <p-dialog [(visible)]="displayAddIngredient" [modal]="true">
      <p-panel header="Add Ingredient" styleClass="ingredient-panel">
        <div class="p-fluid grid">
          <div class="recipe-field">
            <label for="ingredient-name">Ingredient Name</label>
            <input
              id="ingredient-name"
              type="text"
              pInputText
              [(ngModel)]="newIngredient.name"
            />
          </div>
          <div class="recipe-field">
            <label for="ingredient-amount">Ingredient Amount</label>
            <input
              id="ingredient-amount"
              type="text"
              pInputText
              [(ngModel)]="newIngredient.amount"
            />
          </div>
          <div class="recipe-field">
            <label for="ingredient-type">Ingredient Type</label>
            <input
              id="ingredient-type"
              type="text"
              pInputText
              [(ngModel)]="newIngredient.type"
            />
          </div>
        </div>
        <button pButton (click)="saveIngredient()" label="Save"></button>
      </p-panel>
    </p-dialog>
  </p-panel>
</p-dialog>
